Reference documentation and code samples for the Network Services V1 API class Google::Cloud::NetworkServices::V1::ExtensionChain::Extension.
A single extension in the chain to execute for the matching request.
Inherits
- Object
Extended By
- Google::Protobuf::MessageExts::ClassMethods
Includes
- Google::Protobuf::MessageExts
Methods
#authority
def authority() -> ::String-
(::String) — Optional. The
:authorityheader in the gRPC request sent from Envoy to the extension service. Required for Callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.
#authority=
def authority=(value) -> ::String-
value (::String) — Optional. The
:authorityheader in the gRPC request sent from Envoy to the extension service. Required for Callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.
-
(::String) — Optional. The
:authorityheader in the gRPC request sent from Envoy to the extension service. Required for Callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.
#fail_open
def fail_open() -> ::Boolean-
(::Boolean) —
Optional. Determines how the proxy behaves if the call to the extension fails or times out.
When set to
TRUE, request or response processing continues without error. Any subsequent extensions in the extension chain are also executed. When set toFALSEor the default setting ofFALSEis used, one of the following happens:If response headers have not been delivered to the downstream client, a generic 500 error is returned to the client. The error response can be tailored by configuring a custom error response in the load balancer.
If response headers have been delivered, then the HTTP stream to the downstream client is reset.
#fail_open=
def fail_open=(value) -> ::Boolean-
value (::Boolean) —
Optional. Determines how the proxy behaves if the call to the extension fails or times out.
When set to
TRUE, request or response processing continues without error. Any subsequent extensions in the extension chain are also executed. When set toFALSEor the default setting ofFALSEis used, one of the following happens:If response headers have not been delivered to the downstream client, a generic 500 error is returned to the client. The error response can be tailored by configuring a custom error response in the load balancer.
If response headers have been delivered, then the HTTP stream to the downstream client is reset.
-
(::Boolean) —
Optional. Determines how the proxy behaves if the call to the extension fails or times out.
When set to
TRUE, request or response processing continues without error. Any subsequent extensions in the extension chain are also executed. When set toFALSEor the default setting ofFALSEis used, one of the following happens:If response headers have not been delivered to the downstream client, a generic 500 error is returned to the client. The error response can be tailored by configuring a custom error response in the load balancer.
If response headers have been delivered, then the HTTP stream to the downstream client is reset.
#forward_attributes
def forward_attributes() -> ::Array<::String>-
(::Array<::String>) — Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributesfield (of typemap<string, google.protobuf.Struct>), where the keys are the attribute names. Refer to the documentation for the names of attributes that can be forwarded. If omitted, no attributes are sent. Each element is a string indicating the attribute name.
#forward_attributes=
def forward_attributes=(value) -> ::Array<::String>-
value (::Array<::String>) — Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributesfield (of typemap<string, google.protobuf.Struct>), where the keys are the attribute names. Refer to the documentation for the names of attributes that can be forwarded. If omitted, no attributes are sent. Each element is a string indicating the attribute name.
-
(::Array<::String>) — Optional. List of the Envoy attributes to forward to the extension
server. The attributes provided here are included as part of the
ProcessingRequest.attributesfield (of typemap<string, google.protobuf.Struct>), where the keys are the attribute names. Refer to the documentation for the names of attributes that can be forwarded. If omitted, no attributes are sent. Each element is a string indicating the attribute name.
#forward_headers
def forward_headers() -> ::Array<::String>- (::Array<::String>) — Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
#forward_headers=
def forward_headers=(value) -> ::Array<::String>- value (::Array<::String>) — Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
- (::Array<::String>) — Optional. List of the HTTP headers to forward to the extension (from the client or backend). If omitted, all headers are sent. Each element is a string indicating the header name.
#metadata
def metadata() -> ::Google::Protobuf::Struct-
(::Google::Protobuf::Struct) —
Optional. The metadata provided here is included as part of the
metadata_context(of typegoogle.protobuf.Struct) in theProcessingRequestmessage sent to the extension server.For
AuthzExtensionresources, the metadata is available under the namespacecom.google.authz_extension.<resource_name>. For other types of extensions, the metadata is available under the namespacecom.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>. For example:com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.The following variables are supported in the metadata:
{forwarding_rule_id}- substituted with the forwarding rule's fully qualified resource name.This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
#metadata=
def metadata=(value) -> ::Google::Protobuf::Struct-
value (::Google::Protobuf::Struct) —
Optional. The metadata provided here is included as part of the
metadata_context(of typegoogle.protobuf.Struct) in theProcessingRequestmessage sent to the extension server.For
AuthzExtensionresources, the metadata is available under the namespacecom.google.authz_extension.<resource_name>. For other types of extensions, the metadata is available under the namespacecom.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>. For example:com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.The following variables are supported in the metadata:
{forwarding_rule_id}- substituted with the forwarding rule's fully qualified resource name.This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
-
(::Google::Protobuf::Struct) —
Optional. The metadata provided here is included as part of the
metadata_context(of typegoogle.protobuf.Struct) in theProcessingRequestmessage sent to the extension server.For
AuthzExtensionresources, the metadata is available under the namespacecom.google.authz_extension.<resource_name>. For other types of extensions, the metadata is available under the namespacecom.google.<extension_type>.<resource_name>.<extension_chain_name>.<extension_name>. For example:com.google.lb_traffic_extension.lbtrafficextension1.chain1.ext1.The following variables are supported in the metadata:
{forwarding_rule_id}- substituted with the forwarding rule's fully qualified resource name.This field must not be set for plugin extensions. Setting it results in a validation error.
You can set metadata at either the resource level or the extension level. The extension level metadata is recommended because you can pass a different set of metadata through each extension to the backend.
This field is subject to following limitations:
- The total size of the metadata must be less than 1KiB.
- The total number of keys in the metadata must be less than 16.
- The length of each key must be less than 64 characters.
- The length of each value must be less than 1024 characters.
- All values must be strings.
#name
def name() -> ::String-
(::String) — Optional. The name for this extension.
The name is logged as part of the HTTP request logs.
The name must conform with RFC-1034, is restricted to lower-cased
letters, numbers and hyphens, and can have a maximum length of 63
characters. Additionally, the first character must be a letter and the
last a letter or a number.
This field is required except for AuthzExtension.
#name=
def name=(value) -> ::String-
value (::String) — Optional. The name for this extension.
The name is logged as part of the HTTP request logs.
The name must conform with RFC-1034, is restricted to lower-cased
letters, numbers and hyphens, and can have a maximum length of 63
characters. Additionally, the first character must be a letter and the
last a letter or a number.
This field is required except for AuthzExtension.
-
(::String) — Optional. The name for this extension.
The name is logged as part of the HTTP request logs.
The name must conform with RFC-1034, is restricted to lower-cased
letters, numbers and hyphens, and can have a maximum length of 63
characters. Additionally, the first character must be a letter and the
last a letter or a number.
This field is required except for AuthzExtension.
#observability_mode
def observability_mode() -> ::Boolean-
(::Boolean) — Optional. When set to
true, the calls to the extension backend are performed asynchronously, without pausing the processing of the ongoing request. In this mode, onlySTREAMED(default) body processing is supported. Responses, if any, are ignored.Supported by regional
LbTrafficExtensionandLbRouteExtensionresources.
#observability_mode=
def observability_mode=(value) -> ::Boolean-
value (::Boolean) — Optional. When set to
true, the calls to the extension backend are performed asynchronously, without pausing the processing of the ongoing request. In this mode, onlySTREAMED(default) body processing is supported. Responses, if any, are ignored.Supported by regional
LbTrafficExtensionandLbRouteExtensionresources.
-
(::Boolean) — Optional. When set to
true, the calls to the extension backend are performed asynchronously, without pausing the processing of the ongoing request. In this mode, onlySTREAMED(default) body processing is supported. Responses, if any, are ignored.Supported by regional
LbTrafficExtensionandLbRouteExtensionresources.
#request_body_send_mode
def request_body_send_mode() -> ::Google::Cloud::NetworkServices::V1::BodySendMode-
(::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for request body processing.
The field can only be set if
supported_eventsincludesREQUEST_BODY. Ifsupported_eventsincludesREQUEST_BODY, butrequest_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothREQUEST_BODYandREQUEST_TRAILERS.This field can be set only for
LbTrafficExtensionandLbRouteExtensionresources, and only when theservicefield of the extension points to aBackendService. OnlyFULL_DUPLEX_STREAMEDmode is supported forLbRouteExtensionresources.
#request_body_send_mode=
def request_body_send_mode=(value) -> ::Google::Cloud::NetworkServices::V1::BodySendMode-
value (::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for request body processing.
The field can only be set if
supported_eventsincludesREQUEST_BODY. Ifsupported_eventsincludesREQUEST_BODY, butrequest_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothREQUEST_BODYandREQUEST_TRAILERS.This field can be set only for
LbTrafficExtensionandLbRouteExtensionresources, and only when theservicefield of the extension points to aBackendService. OnlyFULL_DUPLEX_STREAMEDmode is supported forLbRouteExtensionresources.
-
(::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for request body processing.
The field can only be set if
supported_eventsincludesREQUEST_BODY. Ifsupported_eventsincludesREQUEST_BODY, butrequest_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothREQUEST_BODYandREQUEST_TRAILERS.This field can be set only for
LbTrafficExtensionandLbRouteExtensionresources, and only when theservicefield of the extension points to aBackendService. OnlyFULL_DUPLEX_STREAMEDmode is supported forLbRouteExtensionresources.
#response_body_send_mode
def response_body_send_mode() -> ::Google::Cloud::NetworkServices::V1::BodySendMode-
(::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for response processing. If
unspecified, the default value
STREAMEDis used.The field can only be set if
supported_eventsincludesRESPONSE_BODY. Ifsupported_eventsincludesRESPONSE_BODY, butresponse_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothRESPONSE_BODYandRESPONSE_TRAILERS.This field can be set only for
LbTrafficExtensionresources, and only when theservicefield of the extension points to aBackendService.
#response_body_send_mode=
def response_body_send_mode=(value) -> ::Google::Cloud::NetworkServices::V1::BodySendMode-
value (::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for response processing. If
unspecified, the default value
STREAMEDis used.The field can only be set if
supported_eventsincludesRESPONSE_BODY. Ifsupported_eventsincludesRESPONSE_BODY, butresponse_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothRESPONSE_BODYandRESPONSE_TRAILERS.This field can be set only for
LbTrafficExtensionresources, and only when theservicefield of the extension points to aBackendService.
-
(::Google::Cloud::NetworkServices::V1::BodySendMode) — Optional. Configures the send mode for response processing. If
unspecified, the default value
STREAMEDis used.The field can only be set if
supported_eventsincludesRESPONSE_BODY. Ifsupported_eventsincludesRESPONSE_BODY, butresponse_body_send_modeis unset, the default valueSTREAMEDis used.When this field is set to
FULL_DUPLEX_STREAMED,supported_eventsmust include bothRESPONSE_BODYandRESPONSE_TRAILERS.This field can be set only for
LbTrafficExtensionresources, and only when theservicefield of the extension points to aBackendService.
#service
def service() -> ::String-
(::String) — Required. The reference to the service that runs the extension.
To configure a callout extension,
servicemust be a fully-qualified reference to a backend service in the format:https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}orhttps://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}.To configure a plugin extension,
servicemust be a reference to aWasmPluginresource in the format:projects/{project}/locations/{location}/wasmPlugins/{plugin}or//networkservices.googleapis.com/projects/{project}/locations/{location}/wasmPlugins/{wasmPlugin}.Plugin extensions are currently supported for the
LbTrafficExtension, theLbRouteExtension, and theLbEdgeExtensionresources.
#service=
def service=(value) -> ::String-
value (::String) — Required. The reference to the service that runs the extension.
To configure a callout extension,
servicemust be a fully-qualified reference to a backend service in the format:https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}orhttps://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}.To configure a plugin extension,
servicemust be a reference to aWasmPluginresource in the format:projects/{project}/locations/{location}/wasmPlugins/{plugin}or//networkservices.googleapis.com/projects/{project}/locations/{location}/wasmPlugins/{wasmPlugin}.Plugin extensions are currently supported for the
LbTrafficExtension, theLbRouteExtension, and theLbEdgeExtensionresources.
-
(::String) — Required. The reference to the service that runs the extension.
To configure a callout extension,
servicemust be a fully-qualified reference to a backend service in the format:https://www.googleapis.com/compute/v1/projects/{project}/regions/{region}/backendServices/{backendService}orhttps://www.googleapis.com/compute/v1/projects/{project}/global/backendServices/{backendService}.To configure a plugin extension,
servicemust be a reference to aWasmPluginresource in the format:projects/{project}/locations/{location}/wasmPlugins/{plugin}or//networkservices.googleapis.com/projects/{project}/locations/{location}/wasmPlugins/{wasmPlugin}.Plugin extensions are currently supported for the
LbTrafficExtension, theLbRouteExtension, and theLbEdgeExtensionresources.
#supported_events
def supported_events() -> ::Array<::Google::Cloud::NetworkServices::V1::EventType>-
(::Array<::Google::Cloud::NetworkServices::V1::EventType>) — Optional. A set of events during request or response processing for which
this extension is called.
For the
LbTrafficExtensionresource, this field is required.For the
LbRouteExtensionresource, this field is optional. If unspecified,REQUEST_HEADERSevent is assumed as supported.For the
LbEdgeExtensionresource, this field is required and must only containREQUEST_HEADERSevent.For the
AuthzExtensionresource, this field is optional.REQUEST_HEADERSis the only supported event. If unspecified,REQUEST_HEADERSevent is assumed as supported.
#supported_events=
def supported_events=(value) -> ::Array<::Google::Cloud::NetworkServices::V1::EventType>-
value (::Array<::Google::Cloud::NetworkServices::V1::EventType>) — Optional. A set of events during request or response processing for which
this extension is called.
For the
LbTrafficExtensionresource, this field is required.For the
LbRouteExtensionresource, this field is optional. If unspecified,REQUEST_HEADERSevent is assumed as supported.For the
LbEdgeExtensionresource, this field is required and must only containREQUEST_HEADERSevent.For the
AuthzExtensionresource, this field is optional.REQUEST_HEADERSis the only supported event. If unspecified,REQUEST_HEADERSevent is assumed as supported.
-
(::Array<::Google::Cloud::NetworkServices::V1::EventType>) — Optional. A set of events during request or response processing for which
this extension is called.
For the
LbTrafficExtensionresource, this field is required.For the
LbRouteExtensionresource, this field is optional. If unspecified,REQUEST_HEADERSevent is assumed as supported.For the
LbEdgeExtensionresource, this field is required and must only containREQUEST_HEADERSevent.For the
AuthzExtensionresource, this field is optional.REQUEST_HEADERSis the only supported event. If unspecified,REQUEST_HEADERSevent is assumed as supported.
#timeout
def timeout() -> ::Google::Protobuf::Duration-
(::Google::Protobuf::Duration) — Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between
10-10000milliseconds. Required for callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.
#timeout=
def timeout=(value) -> ::Google::Protobuf::Duration-
value (::Google::Protobuf::Duration) — Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between
10-10000milliseconds. Required for callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.
-
(::Google::Protobuf::Duration) — Optional. Specifies the timeout for each individual message on the
stream. The timeout must be between
10-10000milliseconds. Required for callout extensions.This field is not supported for plugin extensions. Setting it results in a validation error.